searchData={"items":[{"type":"module","title":"GoogleApi.STS.V1","doc":"API client metadata for GoogleApi.STS.V1.","ref":"GoogleApi.STS.V1.html"},{"type":"function","title":"GoogleApi.STS.V1.discovery_revision/0","doc":"","ref":"GoogleApi.STS.V1.html#discovery_revision/0"},{"type":"module","title":"GoogleApi.STS.V1.Api.V1","doc":"API calls for all endpoints tagged `V1`.","ref":"GoogleApi.STS.V1.Api.V1.html"},{"type":"function","title":"GoogleApi.STS.V1.Api.V1.sts_token/3","doc":"Exchanges a credential for a Google OAuth 2.0 access token. The token asserts an external identity within an identity pool, or it applies a Credential Access Boundary to a Google access token. Note that workforce pools do not support Credential Access Boundaries. When you call this method, do not send the `Authorization` HTTP header in the request. This method does not require the `Authorization` header, and using the header can cause the request to fail.","ref":"GoogleApi.STS.V1.Api.V1.html#sts_token/3"},{"type":"function","title":"Parameters - GoogleApi.STS.V1.Api.V1.sts_token/3","doc":"*   `connection` (*type:* `GoogleApi.STS.V1.Connection.t`) - Connection to server\n*   `optional_params` (*type:* `keyword()`) - Optional parameters\n    *   `:\"$.xgafv\"` (*type:* `String.t`) - V1 error format.\n    *   `:access_token` (*type:* `String.t`) - OAuth access token.\n    *   `:alt` (*type:* `String.t`) - Data format for response.\n    *   `:callback` (*type:* `String.t`) - JSONP\n    *   `:fields` (*type:* `String.t`) - Selector specifying which fields to include in a partial response.\n    *   `:key` (*type:* `String.t`) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token.\n    *   `:oauth_token` (*type:* `String.t`) - OAuth 2.0 token for the current user.\n    *   `:prettyPrint` (*type:* `boolean()`) - Returns response with indentations and line breaks.\n    *   `:quotaUser` (*type:* `String.t`) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters.\n    *   `:uploadType` (*type:* `String.t`) - Legacy upload protocol for media (e.g. \"media\", \"multipart\").\n    *   `:upload_protocol` (*type:* `String.t`) - Upload protocol for media (e.g. \"raw\", \"multipart\").\n    *   `:body` (*type:* `GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.t`) - \n*   `opts` (*type:* `keyword()`) - Call options","ref":"GoogleApi.STS.V1.Api.V1.html#sts_token/3-parameters"},{"type":"function","title":"Returns - GoogleApi.STS.V1.Api.V1.sts_token/3","doc":"*   `{:ok, %GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse{}}` on success\n*   `{:error, info}` on failure","ref":"GoogleApi.STS.V1.Api.V1.html#sts_token/3-returns"},{"type":"module","title":"GoogleApi.STS.V1.Connection","doc":"Handle Tesla connections for GoogleApi.STS.V1.","ref":"GoogleApi.STS.V1.Connection.html"},{"type":"function","title":"GoogleApi.STS.V1.Connection.delete/3","doc":"Perform a DELETE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    delete(\"/users\")\n    delete(\"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\")\n    delete(client, \"/users\", query: [scope: \"admin\"])\n    delete(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#delete/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.delete!/3","doc":"Perform a DELETE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    delete!(\"/users\")\n    delete!(\"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\")\n    delete!(client, \"/users\", query: [scope: \"admin\"])\n    delete!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#delete!/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.execute/2","doc":"Execute a request on this connection","ref":"GoogleApi.STS.V1.Connection.html#execute/2"},{"type":"function","title":"Returns - GoogleApi.STS.V1.Connection.execute/2","doc":"*   `{:ok, Tesla.Env.t}` - If the call was successful\n*   `{:error, reason}` - If the call failed","ref":"GoogleApi.STS.V1.Connection.html#execute/2-returns"},{"type":"function","title":"GoogleApi.STS.V1.Connection.get/3","doc":"Perform a GET request.\n\nSee `request/1` or `request/2` for options definition.\n\n    get(\"/users\")\n    get(\"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\")\n    get(client, \"/users\", query: [scope: \"admin\"])\n    get(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#get/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.get!/3","doc":"Perform a GET request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    get!(\"/users\")\n    get!(\"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\")\n    get!(client, \"/users\", query: [scope: \"admin\"])\n    get!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#get!/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.head/3","doc":"Perform a HEAD request.\n\nSee `request/1` or `request/2` for options definition.\n\n    head(\"/users\")\n    head(\"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\")\n    head(client, \"/users\", query: [scope: \"admin\"])\n    head(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#head/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.head!/3","doc":"Perform a HEAD request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    head!(\"/users\")\n    head!(\"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\")\n    head!(client, \"/users\", query: [scope: \"admin\"])\n    head!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#head!/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.new/0","doc":"Configure an authless client connection","ref":"GoogleApi.STS.V1.Connection.html#new/0"},{"type":"function","title":"Returns - GoogleApi.STS.V1.Connection.new/0","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.STS.V1.Connection.html#new/0-returns"},{"type":"function","title":"GoogleApi.STS.V1.Connection.new/1","doc":"Configure a client connection using a function which yields a Bearer token.","ref":"GoogleApi.STS.V1.Connection.html#new/1"},{"type":"function","title":"Parameters - GoogleApi.STS.V1.Connection.new/1","doc":"*   `token_fetcher` (*type:* `list(String.t()) -> String.t()`) - Callback\n    which provides an OAuth2 token given a list of scopes","ref":"GoogleApi.STS.V1.Connection.html#new/1-parameters"},{"type":"function","title":"Returns - GoogleApi.STS.V1.Connection.new/1","doc":"*   `Tesla.Env.client`","ref":"GoogleApi.STS.V1.Connection.html#new/1-returns"},{"type":"function","title":"GoogleApi.STS.V1.Connection.options/3","doc":"Perform a OPTIONS request.\n\nSee `request/1` or `request/2` for options definition.\n\n    options(\"/users\")\n    options(\"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\")\n    options(client, \"/users\", query: [scope: \"admin\"])\n    options(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#options/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.options!/3","doc":"Perform a OPTIONS request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    options!(\"/users\")\n    options!(\"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\")\n    options!(client, \"/users\", query: [scope: \"admin\"])\n    options!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#options!/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.patch/4","doc":"Perform a PATCH request.\n\nSee `request/1` or `request/2` for options definition.\n\n    patch(\"/users\", %{name: \"Jon\"})\n    patch(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch(client, \"/users\", %{name: \"Jon\"})\n    patch(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#patch/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.patch!/4","doc":"Perform a PATCH request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    patch!(\"/users\", %{name: \"Jon\"})\n    patch!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    patch!(client, \"/users\", %{name: \"Jon\"})\n    patch!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#patch!/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.post/4","doc":"Perform a POST request.\n\nSee `request/1` or `request/2` for options definition.\n\n    post(\"/users\", %{name: \"Jon\"})\n    post(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post(client, \"/users\", %{name: \"Jon\"})\n    post(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#post/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.post!/4","doc":"Perform a POST request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    post!(\"/users\", %{name: \"Jon\"})\n    post!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    post!(client, \"/users\", %{name: \"Jon\"})\n    post!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#post!/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.put/4","doc":"Perform a PUT request.\n\nSee `request/1` or `request/2` for options definition.\n\n    put(\"/users\", %{name: \"Jon\"})\n    put(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put(client, \"/users\", %{name: \"Jon\"})\n    put(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#put/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.put!/4","doc":"Perform a PUT request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    put!(\"/users\", %{name: \"Jon\"})\n    put!(\"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])\n    put!(client, \"/users\", %{name: \"Jon\"})\n    put!(client, \"/users\", %{name: \"Jon\"}, query: [scope: \"admin\"])","ref":"GoogleApi.STS.V1.Connection.html#put!/4"},{"type":"function","title":"GoogleApi.STS.V1.Connection.request/2","doc":"Perform a request.","ref":"GoogleApi.STS.V1.Connection.html#request/2"},{"type":"function","title":"Options - GoogleApi.STS.V1.Connection.request/2","doc":"- `:method` - the request method, one of [`:head`, `:get`, `:delete`, `:trace`, `:options`, `:post`, `:put`, `:patch`]\n- `:url` - either full url e.g. \"http://example.com/some/path\" or just \"/some/path\" if using `Tesla.Middleware.BaseUrl`\n- `:query` - a keyword list of query params, e.g. `[page: 1, per_page: 100]`\n- `:headers` - a keyworld list of headers, e.g. `[{\"content-type\", \"text/plain\"}]`\n- `:body` - depends on used middleware:\n    - by default it can be a binary\n    - if using e.g. JSON encoding middleware it can be a nested map\n    - if adapter supports it it can be a Stream with any of the above\n- `:opts` - custom, per-request middleware or adapter options","ref":"GoogleApi.STS.V1.Connection.html#request/2-options"},{"type":"function","title":"Examples - GoogleApi.STS.V1.Connection.request/2","doc":"ExampleApi.request(method: :get, url: \"/users/path\")\n\n    # use shortcut methods\n    ExampleApi.get(\"/users/1\")\n    ExampleApi.post(client, \"/users\", %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#request/2-examples"},{"type":"function","title":"GoogleApi.STS.V1.Connection.request!/2","doc":"Perform request and raise in case of error.\n\nThis is similar to `request/2` behaviour from Tesla 0.x\n\nSee `request/2` for list of available options.","ref":"GoogleApi.STS.V1.Connection.html#request!/2"},{"type":"function","title":"GoogleApi.STS.V1.Connection.trace/3","doc":"Perform a TRACE request.\n\nSee `request/1` or `request/2` for options definition.\n\n    trace(\"/users\")\n    trace(\"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\")\n    trace(client, \"/users\", query: [scope: \"admin\"])\n    trace(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#trace/3"},{"type":"function","title":"GoogleApi.STS.V1.Connection.trace!/3","doc":"Perform a TRACE request.\n\nSee `request!/1` or `request!/2` for options definition.\n\n    trace!(\"/users\")\n    trace!(\"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\")\n    trace!(client, \"/users\", query: [scope: \"admin\"])\n    trace!(client, \"/users\", body: %{name: \"Jon\"})","ref":"GoogleApi.STS.V1.Connection.html#trace!/3"},{"type":"type","title":"GoogleApi.STS.V1.Connection.option/0","doc":"Options that may be passed to a request function. See `request/2` for detailed descriptions.","ref":"GoogleApi.STS.V1.Connection.html#t:option/0"},{"type":"type","title":"GoogleApi.STS.V1.Connection.t/0","doc":"","ref":"GoogleApi.STS.V1.Connection.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIamV1Binding","doc":"Associates `members`, or principals, with a `role`.","ref":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIamV1Binding","doc":"*   `condition` (*type:* `GoogleApi.STS.V1.Model.GoogleTypeExpr.t`, *default:* `nil`) - The condition that is associated with this binding. If the condition evaluates to `true`, then this binding applies to the current request. If the condition evaluates to `false`, then this binding does not apply to the current request. However, a different role binding might grant the same role to one or more of the principals in this binding. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies).\n*   `members` (*type:* `list(String.t)`, *default:* `nil`) - Specifies the principals requesting access for a Google Cloud resource. `members` can have the following values: * `allUsers`: A special identifier that represents anyone who is on the internet; with or without a Google account. * `allAuthenticatedUsers`: A special identifier that represents anyone who is authenticated with a Google account or a service account. Does not include identities that come from external identity providers (IdPs) through identity federation. * `user:{emailid}`: An email address that represents a specific Google account. For example, `alice@example.com` . * `serviceAccount:{emailid}`: An email address that represents a Google service account. For example, `my-other-app@appspot.gserviceaccount.com`. * `serviceAccount:{projectid}.svc.id.goog[{namespace}/{kubernetes-sa}]`: An identifier for a [Kubernetes service account](https://cloud.google.com/kubernetes-engine/docs/how-to/kubernetes-service-accounts). For example, `my-project.svc.id.goog[my-namespace/my-kubernetes-sa]`. * `group:{emailid}`: An email address that represents a Google group. For example, `admins@example.com`. * `domain:{domain}`: The G Suite domain (primary) that represents all the users of that domain. For example, `google.com` or `example.com`. * `principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workforce identity pool. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/group/{group_id}`: All workforce identities in a group. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All workforce identities with a specific attribute value. * `principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/*`: All identities in a workforce identity pool. * `principal://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/subject/{subject_attribute_value}`: A single identity in a workload identity pool. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/group/{group_id}`: A workload identity pool group. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/attribute.{attribute_name}/{attribute_value}`: All identities in a workload identity pool with a certain attribute. * `principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/*`: All identities in a workload identity pool. * `deleted:user:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a user that has been recently deleted. For example, `alice@example.com?uid=123456789012345678901`. If the user is recovered, this value reverts to `user:{emailid}` and the recovered user retains the role in the binding. * `deleted:serviceAccount:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a service account that has been recently deleted. For example, `my-other-app@appspot.gserviceaccount.com?uid=123456789012345678901`. If the service account is undeleted, this value reverts to `serviceAccount:{emailid}` and the undeleted service account retains the role in the binding. * `deleted:group:{emailid}?uid={uniqueid}`: An email address (plus unique identifier) representing a Google group that has been recently deleted. For example, `admins@example.com?uid=123456789012345678901`. If the group is recovered, this value reverts to `group:{emailid}` and the recovered group retains the role in the binding. * `deleted:principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}`: Deleted single identity in a workforce identity pool. For example, `deleted:principal://iam.googleapis.com/locations/global/workforcePools/my-pool-id/subject/my-subject-attribute-value`.\n*   `role` (*type:* `String.t`, *default:* `nil`) - Role that is assigned to the list of `members`, or principals. For example, `roles/viewer`, `roles/editor`, or `roles/owner`. For an overview of the IAM roles and permissions, see the [IAM documentation](https://cloud.google.com/iam/docs/roles-overview). For a list of the available pre-defined roles, see [here](https://cloud.google.com/iam/docs/understanding-roles).","ref":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIamV1Binding.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary","doc":"An access boundary defines the upper bound of what a principal may access. It includes a list of access boundary rules that each defines the resource that may be allowed as well as permissions that may be used on those resources.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary","doc":"*   `accessBoundaryRules` (*type:* `list(GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.t)`, *default:* `nil`) - A list of access boundary rules which defines the upper bound of the permission a principal may carry. If multiple rules are specified, the effective access boundary is the union of all the access boundary rules attached. One access boundary can contain at most 10 rules.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule","doc":"An access boundary rule defines an upper bound of IAM permissions on a single resource.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule","doc":"*   `availabilityCondition` (*type:* `GoogleApi.STS.V1.Model.GoogleTypeExpr.t`, *default:* `nil`) - The availability condition further constrains the access allowed by the access boundary rule. If the condition evaluates to `true`, then this access boundary rule will provide access to the specified resource, assuming the principal has the required permissions for the resource. If the condition does not evaluate to `true`, then access to the specified resource will not be available. Note that all access boundary rules in an access boundary are evaluated together as a union. As such, another access boundary rule may allow access to the resource, even if this access boundary rule does not allow access. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies). The maximum length of the `expression` field is 2048 characters.\n*   `availablePermissions` (*type:* `list(String.t)`, *default:* `nil`) - A list of permissions that may be allowed for use on the specified resource. The only supported values in the list are IAM roles, following the format of google.iam.v1.Binding.role. Example value: `inRole:roles/logging.viewer` for predefined roles and `inRole:organizations/{ORGANIZATION_ID}/roles/logging.viewer` for custom roles.\n*   `availableResource` (*type:* `String.t`, *default:* `nil`) - The full resource name of a Google Cloud resource entity. The format definition is at https://cloud.google.com/apis/design/resource_names. Example value: `//cloudresourcemanager.googleapis.com/projects/my-project`.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundaryRule.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest","doc":"Request message for ExchangeToken.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest","doc":"*   `audience` (*type:* `String.t`, *default:* `nil`) - The full resource name of the identity provider; for example: `//iam.googleapis.com/projects//locations/global/workloadIdentityPools//providers/` for workload identity pool providers, or `//iam.googleapis.com/locations/global/workforcePools//providers/` for workforce pool providers. Required when exchanging an external credential for a Google access token.\n*   `grantType` (*type:* `String.t`, *default:* `nil`) - Required. The grant type. Must be `urn:ietf:params:oauth:grant-type:token-exchange`, which indicates a token exchange.\n*   `options` (*type:* `String.t`, *default:* `nil`) - A set of features that Security Token Service supports, in addition to the standard OAuth 2.0 token exchange, formatted as a serialized JSON object of Options. The size of the parameter value must not exceed 4096 characters.\n*   `requestedTokenType` (*type:* `String.t`, *default:* `nil`) - Required. An identifier for the type of requested security token. Can be `urn:ietf:params:oauth:token-type:access_token` or `urn:ietf:params:oauth:token-type:access_boundary_intermediate_token`.\n*   `scope` (*type:* `String.t`, *default:* `nil`) - The OAuth 2.0 scopes to include on the resulting access token, formatted as a list of space-delimited, case-sensitive strings. Required when exchanging an external credential for a Google access token.\n*   `subjectToken` (*type:* `String.t`, *default:* `nil`) - Required. The input token. This token is either an external credential issued by a workload identity pool provider, or a short-lived access token issued by Google. If the token is an OIDC JWT, it must use the JWT format defined in [RFC 7523](https://tools.ietf.org/html/rfc7523), and the `subject_token_type` must be either `urn:ietf:params:oauth:token-type:jwt` or `urn:ietf:params:oauth:token-type:id_token`. The following headers are required: - `kid`: The identifier of the signing key securing the JWT. - `alg`: The cryptographic algorithm securing the JWT. Must be `RS256` or `ES256`. The following payload fields are required. For more information, see [RFC 7523, Section 3](https://tools.ietf.org/html/rfc7523#section-3): - `iss`: The issuer of the token. The issuer must provide a discovery document at the URL `/.well-known/openid-configuration`, where `` is the value of this field. The document must be formatted according to section 4.2 of the [OIDC 1.0 Discovery specification](https://openid.net/specs/openid-connect-discovery-1_0.html#ProviderConfigurationResponse). - `iat`: The issue time, in seconds, since the Unix epoch. Must be in the past. - `exp`: The expiration time, in seconds, since the Unix epoch. Must be less than 48 hours after `iat`. Shorter expiration times are more secure. If possible, we recommend setting an expiration time less than 6 hours. - `sub`: The identity asserted in the JWT. - `aud`: For workload identity pools, this must be a value specified in the allowed audiences for the workload identity pool provider, or one of the audiences allowed by default if no audiences were specified. See https://cloud.google.com/iam/docs/reference/rest/v1/projects.locations.workloadIdentityPools.providers#oidc. For workforce pools, this must match the client ID specified in the provider configuration. See https://cloud.google.com/iam/docs/reference/rest/v1/locations.workforcePools.providers#oidc. Example header: ``` { \"alg\": \"RS256\", \"kid\": \"us-east-11\" } ``` Example payload: ``` { \"iss\": \"https://accounts.google.com\", \"iat\": 1517963104, \"exp\": 1517966704, \"aud\": \"//iam.googleapis.com/projects/1234567890123/locations/global/workloadIdentityPools/my-pool/providers/my-provider\", \"sub\": \"113475438248934895348\", \"my_claims\": { \"additional_claim\": \"value\" } } ``` If `subject_token` is for AWS, it must be a serialized `GetCallerIdentity` token. This token contains the same information as a request to the AWS [`GetCallerIdentity()`](https://docs.aws.amazon.com/STS/latest/APIReference/API_GetCallerIdentity) method, as well as the AWS [signature](https://docs.aws.amazon.com/general/latest/gr/signing_aws_api_requests.html) for the request information. Use Signature Version 4. Format the request as URL-encoded JSON, and set the `subject_token_type` parameter to `urn:ietf:params:aws:token-type:aws4_request`. The following parameters are required: - `url`: The URL of the AWS STS endpoint for `GetCallerIdentity()`, such as `https://sts.amazonaws.com?Action=GetCallerIdentity&Version=2011-06-15`. Regional endpoints are also supported. - `method`: The HTTP request method: `POST`. - `headers`: The HTTP request headers, which must include: - `Authorization`: The request signature. - `x-amz-date`: The time you will send the request, formatted as an [ISO8601 Basic](https://docs.aws.amazon.com/general/latest/gr/sigv4_elements.html#sigv4_elements_date) string. This value is typically set to the current time and is used to help prevent replay attacks. - `host`: The hostname of the `url` field; for example, `sts.amazonaws.com`. - `x-goog-cloud-target-resource`: The full, canonical resource name of the workload identity pool provider, with or without an `https:` prefix. To help ensure data integrity, we recommend including this header in the `SignedHeaders` field of the signed request. For example: //iam.googleapis.com/projects//locations/global/workloadIdentityPools//providers/ https://iam.googleapis.com/projects//locations/global/workloadIdentityPools//providers/ If you are using temporary security credentials provided by AWS, you must also include the header `x-amz-security-token`, with the value set to the session token. The following example shows a `GetCallerIdentity` token: ``` { \"headers\": [ {\"key\": \"x-amz-date\", \"value\": \"20200815T015049Z\"}, {\"key\": \"Authorization\", \"value\": \"AWS4-HMAC-SHA256+Credential=$credential,+SignedHeaders=host;x-amz-date;x-goog-cloud-target-resource,+Signature=$signature\"}, {\"key\": \"x-goog-cloud-target-resource\", \"value\": \"//iam.googleapis.com/projects//locations/global/workloadIdentityPools//providers/\"}, {\"key\": \"host\", \"value\": \"sts.amazonaws.com\"} . ], \"method\": \"POST\", \"url\": \"https://sts.amazonaws.com?Action=GetCallerIdentity&Version=2011-06-15\" } ``` If the token is a SAML 2.0 assertion, it must use the format defined in [the SAML 2.0 spec](https://docs.oasis-open.org/security/saml/Post2.0/sstc-saml-tech-overview-2.0-cd-02.pdf), and the `subject_token_type` must be `urn:ietf:params:oauth:token-type:saml2`. See [Verification of external credentials](https://cloud.google.com/iam/docs/using-workload-identity-federation#verification_of_external_credentials) for details on how SAML 2.0 assertions are validated during token exchanges. You can also use a Google-issued OAuth 2.0 access token with this field to obtain an access token with new security attributes applied, such as a Credential Access Boundary. In this case, set `subject_token_type` to `urn:ietf:params:oauth:token-type:access_token`. If an access token already contains security attributes, you cannot apply additional security attributes.\n*   `subjectTokenType` (*type:* `String.t`, *default:* `nil`) - Required. An identifier that indicates the type of the security token in the `subject_token` parameter. Supported values are `urn:ietf:params:oauth:token-type:jwt`, `urn:ietf:params:oauth:token-type:id_token`, `urn:ietf:params:aws:token-type:aws4_request`, `urn:ietf:params:oauth:token-type:access_token`, and `urn:ietf:params:oauth:token-type:saml2`.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenRequest.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse","doc":"Response message for ExchangeToken.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse","doc":"*   `access_boundary_session_key` (*type:* `String.t`, *default:* `nil`) - The access boundary session key. This key is used along with the access boundary intermediate token to generate Credential Access Boundary tokens at client side. This field is absent when the `requested_token_type` from the request is not `urn:ietf:params:oauth:token-type:access_boundary_intermediate_token`.\n*   `access_token` (*type:* `String.t`, *default:* `nil`) - An OAuth 2.0 security token, issued by Google, in response to the token exchange request. Tokens can vary in size, depending in part on the size of mapped claims, up to a maximum of 12288 bytes (12 KB). Google reserves the right to change the token size and the maximum length at any time.\n*   `expires_in` (*type:* `integer()`, *default:* `nil`) - The amount of time, in seconds, between the time when the access token was issued and the time when the access token will expire. This field is absent when the `subject_token` in the request is a Google-issued, short-lived access token. In this case, the access token has the same expiration time as the `subject_token`.\n*   `issued_token_type` (*type:* `String.t`, *default:* `nil`) - The token type. Always matches the value of `requested_token_type` from the request.\n*   `token_type` (*type:* `String.t`, *default:* `nil`) - The type of access token. Always has the value `Bearer`.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1ExchangeTokenResponse.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options","doc":"An `Options` object configures features that the Security Token Service supports, but that are not supported by standard OAuth 2.0 token exchange endpoints, as defined in https://tools.ietf.org/html/rfc8693.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options","doc":"*   `accessBoundary` (*type:* `GoogleApi.STS.V1.Model.GoogleIdentityStsV1AccessBoundary.t`, *default:* `nil`) - An access boundary that defines the upper bound of permissions the credential may have. The value should be a JSON object of AccessBoundary. The access boundary can include up to 10 rules. The size of the parameter value should not exceed 2048 characters.\n*   `userProject` (*type:* `String.t`, *default:* `nil`) - A Google project used for quota and billing purposes when the credential is used to access Google APIs. The provided project overrides the project bound to the credential. The value must be a project number or a project ID. Example: `my-sample-project-191923`. The maximum length is 32 characters.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1Options.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary","doc":"An access boundary defines the upper bound of what a principal may access. It includes a list of access boundary rules that each defines the resource that may be allowed as well as permissions that may be used on those resources.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary","doc":"*   `accessBoundaryRules` (*type:* `list(GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.t)`, *default:* `nil`) - A list of access boundary rules which defines the upper bound of the permission a principal may carry. If multiple rules are specified, the effective access boundary is the union of all the access boundary rules attached. One access boundary can contain at most 10 rules.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule","doc":"An access boundary rule defines an upper bound of IAM permissions on a single resource.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule","doc":"*   `availabilityCondition` (*type:* `GoogleApi.STS.V1.Model.GoogleTypeExpr.t`, *default:* `nil`) - The availability condition further constrains the access allowed by the access boundary rule. If the condition evaluates to `true`, then this access boundary rule will provide access to the specified resource, assuming the principal has the required permissions for the resource. If the condition does not evaluate to `true`, then access to the specified resource will not be available. Note that all access boundary rules in an access boundary are evaluated together as a union. As such, another access boundary rule may allow access to the resource, even if this access boundary rule does not allow access. To learn which resources support conditions in their IAM policies, see the [IAM documentation](https://cloud.google.com/iam/help/conditions/resource-policies). The maximum length of the `expression` field is 2048 characters.\n*   `availablePermissions` (*type:* `list(String.t)`, *default:* `nil`) - A list of permissions that may be allowed for use on the specified resource. The only supported values in the list are IAM roles, following the format of google.iam.v1.Binding.role. Example value: `inRole:roles/logging.viewer` for predefined roles and `inRole:organizations/{ORGANIZATION_ID}/roles/logging.viewer` for custom roles.\n*   `availableResource` (*type:* `String.t`, *default:* `nil`) - The full resource name of a Google Cloud resource entity. The format definition is at https://cloud.google.com/apis/design/resource_names. Example value: `//cloudresourcemanager.googleapis.com/projects/my-project`.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundaryRule.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions","doc":"An `Options` object configures features that the Security Token Service supports, but that are not supported by standard OAuth 2.0 token exchange endpoints, as defined in https://tools.ietf.org/html/rfc8693.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions","doc":"*   `accessBoundary` (*type:* `GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaAccessBoundary.t`, *default:* `nil`) - An access boundary that defines the upper bound of permissions the credential may have. The value should be a JSON object of AccessBoundary. The access boundary can include up to 10 rules. The size of the parameter value should not exceed 2048 characters.\n*   `userProject` (*type:* `String.t`, *default:* `nil`) - A Google project used for quota and billing purposes when the credential is used to access Google APIs. The provided project overrides the project bound to the credential. The value must be a project number or a project ID. Example: `my-sample-project-191923`. The maximum length is 32 characters.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleIdentityStsV1betaOptions.html#t:t/0"},{"type":"module","title":"GoogleApi.STS.V1.Model.GoogleTypeExpr","doc":"Represents a textual expression in the Common Expression Language (CEL) syntax. CEL is a C-like expression language. The syntax and semantics of CEL are documented at https://github.com/google/cel-spec. Example (Comparison): title: \"Summary size limit\" description: \"Determines if a summary is less than 100 chars\" expression: \"document.summary.size() < 100\" Example (Equality): title: \"Requestor is owner\" description: \"Determines if requestor is the document owner\" expression: \"document.owner == request.auth.claims.email\" Example (Logic): title: \"Public documents\" description: \"Determine whether the document should be publicly visible\" expression: \"document.type != 'private' && document.type != 'internal'\" Example (Data Manipulation): title: \"Notification string\" description: \"Create a notification string with a timestamp.\" expression: \"'New message received at ' + string(document.create_time)\" The exact variables and functions that may be referenced within an expression are determined by the service that evaluates it. See the service documentation for additional information.","ref":"GoogleApi.STS.V1.Model.GoogleTypeExpr.html"},{"type":"module","title":"Attributes - GoogleApi.STS.V1.Model.GoogleTypeExpr","doc":"*   `description` (*type:* `String.t`, *default:* `nil`) - Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.\n*   `expression` (*type:* `String.t`, *default:* `nil`) - Textual representation of an expression in Common Expression Language syntax.\n*   `location` (*type:* `String.t`, *default:* `nil`) - Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.\n*   `title` (*type:* `String.t`, *default:* `nil`) - Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.","ref":"GoogleApi.STS.V1.Model.GoogleTypeExpr.html#module-attributes"},{"type":"function","title":"GoogleApi.STS.V1.Model.GoogleTypeExpr.decode/2","doc":"Unwrap a decoded JSON object into its complex fields.","ref":"GoogleApi.STS.V1.Model.GoogleTypeExpr.html#decode/2"},{"type":"type","title":"GoogleApi.STS.V1.Model.GoogleTypeExpr.t/0","doc":"","ref":"GoogleApi.STS.V1.Model.GoogleTypeExpr.html#t:t/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}